"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var listen_1 = require("./listen");
function touchGestureListener(el, start) {
    var isDown = false;
    var isCanceled = false;
    var hasMoved = false;
    var moveListener;
    var endListener;
    var tapListener;
    var startTime = 0;
    var _startListener = listen_1.listen(el, ["mousedown", "touchstart"], function (startEv) {
        isDown = true;
        hasMoved = false;
        isCanceled = false;
        startTime = Date.now();
        start({
            ev: startEv,
            move: function (listener) { return (moveListener = listener); },
            end: function (listener) { return (endListener = listener); },
            tap: function (listener) { return (tapListener = listener); },
            cancel: function () { return (isCanceled = true); }
        });
    });
    var _moveListener = listen_1.listen(window, ["mousemove", "touchmove"], function (moveEv) {
        if (isDown) {
            hasMoved = true;
        }
        if (!isCanceled && isDown && moveListener) {
            moveListener(moveEv);
        }
    });
    var _endListener = listen_1.listen(window, ["mouseup", "touchend"], function (endEv) {
        var endTime = Date.now();
        if (!isCanceled && isDown && endListener) {
            endListener(endEv);
        }
        if (!hasMoved && endTime - startTime < 350 && tapListener) {
            tapListener(endEv);
        }
        isDown = false;
    });
    return function () {
        _startListener();
        _moveListener();
        _endListener();
    };
}
exports.touchGestureListener = touchGestureListener;
function getEventY(ev) {
    return "touches" in ev ? ev.touches[0].clientY : ev.clientY;
}
exports.getEventY = getEventY;
function getEventX(ev) {
    return "touches" in ev ? ev.touches[0].clientX : ev.clientX;
}
exports.getEventX = getEventX;
//# sourceMappingURL=touch-gesture-listener.js.map